package agent;

import geometry.Degree;
import geometry.Line;
import geometry.Point;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.TreeSet;
import utilities.Logger;

import rescuecore2.standard.entities.Building;

public class FireZone {
	public Logger logger = null;
	public int time = -1;

	public void setAroundBuildings() {
		float minTheta = Integer.MAX_VALUE, b = 0, a;
		Point minPoint = new Point();
		Point pointMoredeNazar = new Point();
		TreeSet<Point> pointsM = new TreeSet<Point>();

		for (Building building : ignitedBuilds)
			for (int i = 0; i < building.worldGraphArea.points.size() - 1; i++) {
				building.worldGraphArea.points.get(i).tmp = building;
				pointsM.add(building.worldGraphArea.points.get(i));
			}

		minPoint = Collections.min(pointsM);

		aroundBuildings = new HashSet<Building>();
		Line line = new Line(minPoint, null);
		while (true) {
			minTheta = Integer.MAX_VALUE;
			float minB = -1;
			for (Point secondPoint : pointsM)
				if (secondPoint != line.getFirstPoint()) {
					line.setSecondPoint(secondPoint);
					a = line.getTheta();
					if (Degree.absoluteAngle(a - b) < minTheta) {
						pointMoredeNazar = secondPoint;
						minTheta = Degree.absoluteAngle(a - b);
						minB = a;
					}
				}
			b = minB;
			if (pointMoredeNazar == minPoint)
				break;

			line.setFirstPoint(pointMoredeNazar);
			aroundBuildings.add(pointMoredeNazar.tmp);
		}
	}

	public int zoneNum = -1;
	public Point centerPoint = null;
	public int workersNum;
	public int value = 0;
	public int centerX = 0;
	public int centerY = 0;
	public int volume = 0;
	public boolean isInhibitor = false;
	public ArrayList<Building> ignitedBuilds = new ArrayList<Building>();
	public ArrayList<Building> buildings = new ArrayList<Building>();
	public HashSet<Building> aroundBuildings = new HashSet<Building>();

	public FireZone(int num) {
		zoneNum = num;
	}
}
