package worldGraph;

import geometry.Point;
import graph.Node;
import java.util.ArrayList;
import rescuecore2.standard.entities.AmbulanceTeam;
import rescuecore2.standard.entities.Civilian;

public class Enterance {
	public ArrayList<Point> points = new ArrayList<Point>();
	public ArrayList<Point> avaialablePoints = null;

	public ArrayList<Node> nodes = null;
	public int index = -1;
	public int id = -1;
	public int rad = -1;
	public boolean isItConnectedToNeighbour = true;
	public boolean isCheck = false;
	public boolean star = false;// for Ambulance search
	public boolean mark = false;
	public boolean isTarget = false;
	public Enterance lastEnterance = null;
	public ArrayList<Civilian> civilians = new ArrayList<Civilian>(); // for
	// ambulance
	public ArrayList<AmbulanceTeam> ambulances = new ArrayList<AmbulanceTeam>(); // for
	// ambulance
	public rescuecore2.standard.entities.Area neighbourAreaInModel = null;

	public Enterance() {
	}

	public Enterance(int id, int index, Area area, int rad) {
		this.id = id;
		this.index = index;
		this.area = area;
		this.rad = rad;
	}

	public Enterance(int id, int index, Area area, int rad,
			rescuecore2.standard.entities.Area neighbourAreaInModel) {
		this.id = id;
		this.index = index;
		this.area = area;
		this.rad = rad;
		this.neighbourAreaInModel = neighbourAreaInModel;
	}

	public void createPoints() {
		points = area.getSafePoints(index, rad, false);
		points.addAll(area.getSafePoints(index, rad / 4, false));
		int mult = 1;
		while (points.size() == 0 && mult < 40) {
			points = area.getHeySafePoints(index, rad / mult, false);
			mult *= 2;
		}
		if (points.size() == 0)
			System.err.println("A: " + toString() + " " + area.points);
		avaialablePoints = points;
	}

	public void updateAvaiablePoints() {
		avaialablePoints = new ArrayList<Point>();
		for (Point point : points)
			if (!area.hasConflictWithBlockades(point, rad))
				avaialablePoints.add(point);
	}

	public Area area = null;
	public Enterance neighbour = null;

	public ArrayList<Enterance> internalEnterances = null;

	public void updateConnectivity(boolean isNeighbourInChangeSet) {
		boolean lastValue = isItConnectedToNeighbour;
		isItConnectedToNeighbour = false;

		if (isNeighbourInChangeSet || lastValue) {
			done: for (Point point : avaialablePoints)
				for (Point other : neighbour.avaialablePoints)
					if (area.isThereWay(point, other, rad, true)
							&& neighbour.area.isThereWay(point, other, rad,
									true)) {
						isItConnectedToNeighbour = true;
						break done;
					}
		}

		neighbour.isItConnectedToNeighbour = isItConnectedToNeighbour;
	}

	public String toString() {
		return ((area.modelArea != null) ? (area.modelArea.getID().getValue() + " ")
				: "")
				+ index
				+ " "
				+ neighbourAreaInModel.getID().getValue()
				+ " "
				+ isItConnectedToNeighbour;
	}
}
